﻿// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//
// Copyright (c) Microsoft Corporation. All rights reserved.

namespace Microsoft.Samples.Commerce.Order.CommerceEntities
{
    /// <summary>
    /// Contains constants for common status codes for a Basket
    /// </summary>
    public static class BasketStatus
    {
        #region Constants

        /// <summary>
        /// The basket is still being built. Totals are not ready for review.
        /// </summary>
        public const string InProcess = "InProcess";

        /// <summary>
        /// The basket totals are ready to be reviewed.
        /// </summary>
        public const string ReadyForCheckout = "ReadyForCheckout";

        /// <summary>
        /// The basket is ready to be converted to an order.
        /// </summary>
        public const string Ordered = "Ordered";

        #endregion
    }
}
