// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//
// Copyright (c) Microsoft Corporation. All rights reserved.

namespace Microsoft.Samples.Commerce.Order.CommerceEntities
{
    /// <summary>
    /// Specifies the meaning of numeric data in the Discount.Value property. 
    /// </summary>
    public static class DiscountType
    {
        /// <summary>
        /// Value not set
        /// </summary>
        public const int None = 0;

        /// <summary>
        /// Data is recorded as currency.
        /// </summary>
        public const int CurrencyValue = 1;

        /// <summary>
        /// Data is recorded as a percentage. 
        /// </summary>
        public const int Percentage = 2;
    }
}
