﻿// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//
// Copyright (c) Microsoft Corporation. All rights reserved.

namespace Microsoft.Samples.Commerce.Order.CommerceEntities
{
    using Microsoft.Commerce.Contracts;

    /// <summary>
    /// Defines a list of payment types.
    /// </summary>
    /// <remarks>
    ///  Numeric values correspond to the values defined in Commerce Server.
    /// </remarks>
    public static class PaymentType
    {
        /// <summary>
        /// Payment Node type.
        /// </summary>
        public const int None = 0;
        
        /// <summary>
        /// Payment CreditCard type.
        /// </summary>
        public const int CreditCard = 1;
        
        /// <summary>
        /// Payment GiftCertificate type.
        /// </summary>
        public const int GiftCertificate = 2;
        
        /// <summary>
        /// Payment PurchaseOrder type.
        /// </summary>
        public const int PurchaseOrder = 3;
        
        /// <summary>
        /// Payment CashCard type.
        /// </summary>
        public const int CashCard = 4;
        
        /// <summary>
        /// Payment Custom type.
        /// </summary>
        public const int Custom = 5;
        
        /// <summary>
        /// Payment Custom1 type.
        /// </summary>
        public const int Custom1 = 6;
        
        /// <summary>
        /// Payment Custom2 type.
        /// </summary>
        public const int Custom2 = 7;
        
        /// <summary>
        /// Payment Custom3 type.
        /// </summary>
        public const int Custom3 = 8;
        
        /// <summary>
        /// Payment Custom4 type.
        /// </summary>
        public const int Custom4 = 9;
        
        /// <summary>
        /// Payment Custom5 type.
        /// </summary>
        public const int Custom5 = 10;
    }
}
